var EcoMailzConnectionHandler  = {
getConnectHash:function(ecoMailzConnectionSettings)
{
	var sslFlag = new Boolean(ecoMailzConnectionSettings.ssl);
	var sslStr = sslFlag.toString();
    return (EcoMailzEncryptionHandler.getHash(ecoMailzConnectionSettings.server) + 
            EcoMailzEncryptionHandler.getHash(ecoMailzConnectionSettings.port) + 
            EcoMailzEncryptionHandler.getHash(sslStr) + 
            EcoMailzEncryptionHandler.getHash(ecoMailzConnectionSettings.apiPath) + 
            EcoMailzEncryptionHandler.getHash(ecoMailzConnectionSettings.username) + 
            EcoMailzEncryptionHandler.getHash(ecoMailzConnectionSettings.password)).toString(); 
},

checkConnection:function(ecoMailzConnectionSettings, successCallback, errorCallback)
{    
    var hash = EcoMailzConnectionHandler.getConnectHash(ecoMailzConnectionSettings);
    
    if(!ecoMailzConnection.connected || hash !== ecoMailzConnection.lastHash)
    {
        ecoMailzConnection.lastHash = hash;
        
        if(ecoMailzConnection.connected)
        {
            EcoMailzRestService.disconnectAndConnect(ecoMailzConnectionSettings, successCallback, errorCallback);
        }
        else
        {
            EcoMailzRestService.connect(ecoMailzConnectionSettings, successCallback, errorCallback);
        }
    }
    else
    {
        successCallback(null, null, null, EcoMailzHelper.getGlobalProperty(INFO_ID_CONNECTION_ALREADY_CONNECTED));
    }
}
}