var ecoMailzConnectionSettings = {
    url:"",
    server:"localhost",
    port:"8888",
    ssl:false,
    apiPath:"/restful/api",
    username:"",
    password:"",
    encryptedPassword:"",
    sharedSecret:"",
    settingsLoaded:false,
    count:0
};

var EcoMailzSettings = 
{
		async loadSettings()
		{
			var updateStr = null;
			var result = await browser.storage.local.get("ecoMailzPreferences");
			if(result && result.ecoMailzPreferences)
			{
				updateStr = result.ecoMailzPreferences.value;
			}
				 
			await EcoMailzSettings.updateSettings(updateStr);
		},
		
		async updateSettings(settingsStr) {
			
			if(!settingsStr || settingsStr === null)
			{
				return;				
			}
			    var settingsArr = settingsStr.split("\r\n");
    

    for(var i = 0; i < settingsArr.length; i++)
    {
        var tmpSetting = settingsArr[i];
        var tmpIndex = tmpSetting.indexOf("=");
        
 
        
        var settingName = tmpSetting.substring(0, tmpIndex);
        
                
        var settingValue = tmpSetting.substring(tmpIndex+1, tmpSetting.length);
        
        switch(settingName)
        {
            case SETTINGS_FILE_URL:
                ecoMailzConnectionSettings.url = settingValue;
                break;
                
            case SETTINGS_FILE_SERVER:
                ecoMailzConnectionSettings.server = settingValue;
                break;
                
            case SETTINGS_FILE_PORT:
                ecoMailzConnectionSettings.port = settingValue;
                break;
                
            case SETTINGS_FILE_SSL:
                ecoMailzConnectionSettings.ssl = EcoMailzSettings.stringToBoolean(settingValue);
                break;
       
            case SETTINGS_FILE_APIPATH:
                ecoMailzConnectionSettings.apiPath = settingValue;
                break;
         
            case SETTINGS_FILE_USERNAME:
                ecoMailzConnectionSettings.username = settingValue;
                break;
                
            case SETTINGS_FILE_SHARED_SECRET:
                ecoMailzConnectionSettings.sharedSecret = settingValue;                
                break;
                
            case SETTINGS_FILE_ENCRYPTED_PASSWORD:
                ecoMailzConnectionSettings.encryptedPassword = settingValue;                 
                break;
                
        }
    }
    ecoMailzConnectionSettings.password = await EcoMailzEncryptionHandler.getDecryptedString(ecoMailzConnectionSettings.sharedSecret, ecoMailzConnectionSettings.encryptedPassword);
		},

		async saveSettings()
		{
			var connectionStr = EcoMailzSettings.getConnectionString();
			let ecoMailzPreferences = {
				value: connectionStr
			};
			// TODO: PUT: CALLBACKS
			browser.storage.local.set({ecoMailzPreferences})
				.then(EcoMailzSettings.setItem, EcoMailzSettings.onError);
		},
		
		setItem() {
  console.log("Settings saved");
},


onError(error) {
  console.log("err");
},
		
		testSettings()
		{
			
		},
		
		getConnectionString()
{
    var ret = "";
    
    ret = EcoMailzSettings.addSettingToBuffer(ret, SETTINGS_FILE_URL, ecoMailzConnectionSettings.url, false);
    ret = EcoMailzSettings.addSettingToBuffer(ret, SETTINGS_FILE_SERVER, ecoMailzConnectionSettings.server, false);
    ret = EcoMailzSettings.addSettingToBuffer(ret, SETTINGS_FILE_PORT, ecoMailzConnectionSettings.port, false);
    ret = EcoMailzSettings.addSettingToBuffer(ret, SETTINGS_FILE_SSL, ecoMailzConnectionSettings.ssl, false);
    ret = EcoMailzSettings.addSettingToBuffer(ret, SETTINGS_FILE_APIPATH, ecoMailzConnectionSettings.apiPath, false);
    ret = EcoMailzSettings.addSettingToBuffer(ret, SETTINGS_FILE_USERNAME, ecoMailzConnectionSettings.username, false);
    ret = EcoMailzSettings.addSettingToBuffer(ret, SETTINGS_FILE_SHARED_SECRET, ecoMailzConnectionSettings.sharedSecret, false);
    ret = EcoMailzSettings.addSettingToBuffer(ret, SETTINGS_FILE_ENCRYPTED_PASSWORD, ecoMailzConnectionSettings.encryptedPassword, true);
    
    return ret;
},

		addSettingToBuffer(buffer, settingName, settingValue, isLastSetting)
{
    buffer += settingName;
    buffer += SETTINGS_FILE_ASSIGNMENT;
    buffer += settingValue;
    
    if(!isLastSetting)
    {
        buffer += SETTINGS_FILE_SEPARATOR;        
    }
            
    return buffer;
},

stringToBoolean(str)
{
    switch(str.toLowerCase().trim()){
        case "true": case "yes": case "1": return true;
        case "false": case "no": case "0": case null: return false;
        default: return Boolean(str);
    }
}
};