var LOG_PREFIX = "ecoMailz:";

var MAILZ_ALERT_TITLE = "ecoMAILZ";

var MAILZ_STATUS_INVALID = "-1";
var MAILZ_STATUS_ERROR = "0";
var MAILZ_STATUS_TODELETE = "1";
var MAILZ_STATUS_ARCHIVED = "2";
var MAILZ_STATUS_NOTINMAILZ = "3";
var MAILZ_STATUS_TOARCHIVE = "4";
var MAILZ_STATUS_DELETED = "7";
var MAILZ_STATUS_DELETIONREQUEST = "666";
var MAILZ_STATUS_NOTCONFIGURED = "99";
var MAILZ_STATUS_LOADING = "L";
var MAILZ_STATUS_EMG = "EMG";
var EMG_COUNT = 100;

var MAILZ_CMD = "mailzCMD";

var MAILZ_CMD_SKIPDEADLINE = "mailzSkipDeadline";
var MAILZ_CMD_MARK_DELETE = "mailzMarkDelete";
var MAILZ_CMD_UNDO_DELETE = "mailzUndoDelete";


var INDEX_OPTIONAL_STATUS_DELETION_REQUEST = "1";
	
var MAILZ_INTERNAL_STATUS_ARRAY_ARCHIVED = ["3", "10"];
var MAILZ_INTERNAL_STATUS_ARRAY_TOARCHIVE = ["1"];
var MAILZ_INTERNAL_STATUS_ARRAY_TODELETE = ["4"];
var MAILZ_INTERNAL_STATUS_ARRAY_DELETED = ["7"];

var MAILZ_POPUP_TOARCHIVE = "popups/toArchivePopup.html";
var MAILZ_POPUP_MARKEDFORDELETE = "popups/markedForDeletePopup.html";

var MAILZ_BUTTON_ID_ERROR = "ecoMailzErrorButton";
var MAILZ_BUTTON_ID_ARCHIVED = "ecoMailzArchivedButton"; 
var MAILZ_BUTTON_ID_EMG = "ecoMailzEmgButton"; 
var MAILZ_BUTTON_ID_NOTINMAILZ = "ecoMailzNotInMailzButton"; 
var MAILZ_BUTTON_ID_TOARCHIVE = "ecoMailzToArchiveButton"; 
var MAILZ_BUTTON_ID_TODELETE = "ecoMailzToDeleteButton"; 
var MAILZ_BUTTON_ID_DELETED = "ecoMailzDeletedButton"; 
var MAILZ_BUTTON_ID_DELETIONREQUEST = "ecoMailzDeletionRequestButton"; 
var MAILZ_BUTTON_ID_LOADING = "ecoMailzLoadingButton"; 
var MAILZ_BUTTON_ID_NOTCONFIGURED = "ecoMailzNotConfiguredButton"; 

var MAILZ_LOGO_ERROR = "images/ecomailz_logo_error_256.png";
var MAILZ_LOGO_BLACK = "images/ecomailz_logo_black_256.png";
var MAILZ_LOGO_EMG = "images/ecomailz_logo_emg_256.png";
var MAILZ_LOGO_GREEN = "images/ecomailz_logo_green_256.png";
var MAILZ_LOGO_GREY = "images/ecomailz_logo_grey_256.png";
var MAILZ_LOGO_LOADING = "images/ecomailz_logo_loading_256.gif";
var MAILZ_LOGO_NOTCONFIGURED = "images/ecomailz_logo_notconfigured_256.png";
var MAILZ_LOGO_ORANGE = "images/ecomailz_logo_orange_256.png";
var MAILZ_LOGO_RED = "images/ecomailz_logo_red_256.png";
var MAILZ_LOGO_WHITE = "images/ecomailz_logo_white_256.png";
var MAILZ_POPUP_BUTTON_DELETE = "images/ecomailz_delete_64.png";
var MAILZ_POPUP_BUTTON_UNDO_DELETE = "images/ecomailz_delete_undo_64.png";
var MAILZ_POPUP_BUTTON_SKIP_DEADLINE = "images/ecomailz_skip_viewing_deadline_64.png";

var MAILZ_STATUS_BUTTON_IDS = [MAILZ_BUTTON_ID_ERROR, MAILZ_BUTTON_ID_ARCHIVED, MAILZ_BUTTON_ID_EMG, MAILZ_BUTTON_ID_NOTINMAILZ, MAILZ_BUTTON_ID_TOARCHIVE, MAILZ_BUTTON_ID_TODELETE, MAILZ_BUTTON_ID_LOADING, MAILZ_BUTTON_ID_NOTCONFIGURED, MAILZ_BUTTON_ID_DELETED, MAILZ_BUTTON_ID_DELETIONREQUEST];

var DEFAULT_ENCODING = "UTF-8";
var DEFAULT_REQUEST_GET_TIMEOUT = 10000;

var BUTTON_TEXT_ARCHIVED = "buttonArchivedTooltip";
var BUTTON_TEXT_NOT_IN_MAILZ = "buttonNotInMailzTooltip";
var BUTTON_TEXT_TO_ARCHIVE = "buttonToArchiveTooltip";
var BUTTON_TEXT_MARKED_FOR_DELETE = "buttonToDeleteTooltip";
var BUTTON_TEXT_DELETED = "buttonDeletedTooltip";
var BUTTON_TEXT_DELETION_REQUEST = "buttonDeletionRequestTooltip";
var BUTTON_TEXT_LOADING = "buttonLoadingTooltip";
var BUTTON_TEXT_EMG = "mailzEMG";

var ERROR_ID_NO_CONNECTION_OR_ERROR = "buttonErrorTooltip";
var ERROR_ID_NOT_CONFIGURED = "buttonNotConfiguredTooltip";

var ERROR_ID_SERVER_MANDATORY = "errorSettingsServerMandatory";
var ERROR_ID_PORT_MANDATORY = "errorSettingsPortMandatory";
var ERROR_ID_APIPATH_MANDATORY = "errorSettingsApiPathMandatory";
var ERROR_ID_USERNAME_MANDATORY = "errorSettingsUserMandatory";
var ERROR_ID_PASSWORD_MANDATORY = "errorSettingsPasswordMandatory";
var ERROR_ID_URL_INVALID = "errorSettingsConnectInvalidUrl";
var ERROR_ID_MAILSELECTION = "errorMailSelection";
var ERROR_ID_REST_GENERALERROR = "errorRestGeneral";

var ERROR_ID_SETTINGS_FIELD_MANDATORY = "errorSettingsFieldMandatory";

var ID_EMG = "mailzEMG";

var INFO_ID_CONNECTION_ALREADY_CONNECTED = "settingsConnectAlreadyConnected";

var ENCRYPTION_MESSAGE_ID = "SHA-256";

// Supported values are: SHA-1, SHA-256, SHA-384, and SHA-512.
var ENCRYPTION_HASH_FUNCTION = ENCRYPTION_MESSAGE_ID;
// Supported values are: raw, pkcs8, spki and jwk.
var ENCRYPTION_KEY_FORMAT = "raw";
// Supported values are: AES-CBC, AES-CTR, AES-GCM and RSA-OAEP (MIND that the source must be altered as well)
var ENCRYPTION_ALGORITH = "AES-GCM";
var ENCRYPTION_IV_STRING = "ecoMAILZEncryptionIV";

var REQUEST_TYPE_GET = "GET";
var REQUEST_GET_CONNECT = "connect";
var REQUEST_GET_DISCONNECT = "disconnect";

var CONNECTION_SUCCESS_MESSAGE_PREFIX = '"login successful [';
var CONNECTION_SUCCESS_MESSAGE_POSTFIX= ']"';

var REQUEST_TYPE_POST = "POST";
var REQUEST_POST_SEARCHMAIL = "searchMail";
var REQUEST_POST_MARKDELETION = "markDeletion";
var REQUEST_POST_UNDODELETION = "undoDeletion";
var REQUEST_POST_SKIPDEADLINE = "skipDeadLine";
var REQUEST_POST_UNDOSKIPDEADLINE = "undoSkipDeadLine";

var BOOLEAN_REQUEST_SUCCESS = "true";

var SEARCH_MAIL_CHECKSUM = "checksum:";

var MESSAGE_ID_PREFIX_DELETED = "ecoMAILZ@DELETED_";

var MAIL_HEADER_MESSAGE_ID = "message-id";
var MAIL_HEADER_DELIVERED_TO = "delivered-to";

var CONNECT_REQUEST_HEADER_AUTHORIZATION = "Authorization";
var CONNECT_REQUEST_USERDATA_PREFIX = "Basic";

var POST_REQUEST_HEADER_CONTENT_TYPE = "Content-type";
var POST_REQUEST_HEADER_CONTENT_TYPE_DEFAULT_VALUE = "application/json";

var POST_REQUEST_HEADER_CONTENT_LENGTH = "Content-length";

var SETTINGS_SUBMIT_BUTTON = "mailzSubmitButton";


var SETTINGS_FILE_URL = "mailzUrl";
var SETTINGS_FILE_SERVER = "mailzServer";
var SETTINGS_FILE_PORT = "mailzPort";
var SETTINGS_FILE_SSL = "mailzSsl";
var SETTINGS_FILE_APIPATH = "mailzApiPath";
var SETTINGS_FILE_USERNAME = "mailzUser";
var SETTINGS_FILE_SHARED_SECRET = "mailzSharedSecret";
var SETTINGS_FILE_PASSWORD = "mailzPassword";
var SETTINGS_FILE_ENCRYPTED_PASSWORD = "mailzEncryptedPassword";
var SETTINGS_FILE_SEPARATOR = "\r\n";
var SETTINGS_FILE_ASSIGNMENT = "=";
var SETTINGS_MAILZ_INFO = "mailzInfo";
var SETTINGS_API_PATH_CONTAINER = "mailzApiPathContainer";

var SETTINGS_IMG_SOURCE_EXPAND_LESS = "../images/ecomailz_expand_less_24.png";
var SETTINGS_IMG_SOURCE_EXPAND_MORE = "../images/ecomailz_expand_more_24.png";

var SETTINGS_FILE_VALID_SETTINGS = [SETTINGS_FILE_URL, SETTINGS_FILE_SERVER, SETTINGS_FILE_PORT, SETTINGS_FILE_SSL, SETTINGS_FILE_APIPATH, SETTINGS_FILE_USERNAME, SETTINGS_FILE_SHARED_SECRET, SETTINGS_FILE_ENCRYPTED_PASSWORD];

var SETTINGS_FILE_LOAD_FAILED_PROPERTY = "errorSettingsFileLoadFailed";
var SETTINGS_FILE_LOAD_FAILED_INVALIDFILE_PROPERTY = "errorSettingsFileLoadFailedInvalidFile";
var SETTINGS_FILE_LOAD_FAILED_INVALIDFILE_NOTENOUGHSETTINGS_PROPERTY = "errorSettingsFileLoadFailedInvalidFileNotEnoughSettings";
var SETTINGS_FILE_LOAD_FAILED_INVALIDFILE_INVALIDLINE_PROPERTY = "errorSettingsFileLoadFailedInvalidFileInvalidLine";
var SETTINGS_FILE_LOAD_FAILED_INVALIDFILE_INVALIDSETTING_PROPERTY = "errorSettingsFileLoadFailedInvalidFileInvalidSetting";

var SETTINGS_WINDOW_ID = "ecoMailzSettingsWindow";

var SETTINGS_BUTTON_ID_TEST = "ecoMailzSettingsTestButton";
var SETTINGS_BUTTON_ID_SUBMIT = "ecoMailzSettingsSubmitButton";

var SETTINGS_INPUT_ID_SERVER = "ecoMailzSettingsServerInput";
var SETTINGS_INPUT_ID_PORT = "ecoMailzSettingsPortInput";
var SETTINGS_INPUT_ID_USERNAME = "ecoMailzSettingsUsernameInput";
var SETTINGS_INPUT_ID_PASSWORD = "ecoMailzSettingsPasswordInput";
var SETTINGS_INPUT_ID_APIPATH = "ecoMailzSettingsApiPathInput";

var SETTINGS_OUTPUT_ID_URL = "ecoMailzSettingsUrlOutput";

var SETTINGS_CHECKBOX_ID_SSL = "ecoMailzSettingsSslCheckbox";

var CONNECTION_SUCCESSFUL_PROPERTY = "settingsConnectSuccessful";
var CONNECTION_FAILED_PROPERTY = "errorSettingsConnectFailed";
var SETTINGS_FILE_SAVE_FAILED_PROPERTY = "errorSettingsFileSaveFailed";
var SETTINGS_FILE_SAVE_FAILED_CREATEFAILED_PROPERTY = "errorSettingsFileCreateFailed";

var SETTINGS_SAVED = "settingsSaved";

var MAILZ_GENERATE_MESSAGEID_POSTFIX = "@ecomailz.de";

var SETTINGS_BUTTON_ID_ADVANCED = "ecoMailzSettingsAdvancedButton";
var SETTINGS_BOX_ID_ADVANCED = "ecoMailzSettingsAdvancedBox";


var SETTINGS_SSL = "https://";
var SETTINGS_NO_SSL = "http://";

var SETTINGS_SERVER_PORT_SEPARATOR = ":";

var SETTINGS_DEFAULT_SERVER = "localhost";
var SETTINGS_DEFAULT_PORT = 8888;
var SETTINGS_DEFAULT_SSL = false;
var SETTINGS_DEFAULT_APIPATH = "/restful/api";
